"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var utils_1 = require("./utils");
var useFormUIEvents = function (eventOptionList) {
    var _a = (0, react_1.useReducer)(utils_1.eventStoreReducer, eventOptionList, utils_1.eventBusFromArray), state = _a[0], dispatch = _a[1];
    var subscribe = (0, react_1.useCallback)(function (eventName, handler) {
        var eventObjectToken = Symbol();
        dispatch({
            type: utils_1.EventActionsTypes.subscribe,
            payload: { eventName: eventName, handler: handler, token: eventObjectToken },
        });
        return function () {
            dispatch({
                type: utils_1.EventActionsTypes.unsubscribe,
                payload: { eventName: eventName, token: eventObjectToken },
            });
        };
    }, []);
    var emit = (0, react_1.useCallback)(function (eventName) {
        dispatch({
            type: utils_1.EventActionsTypes.emit,
            payload: { eventName: eventName }
        });
    }, []);
    return { emit: emit, subscribe: subscribe };
};
exports.default = useFormUIEvents;
