"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.eventStoreReducer = exports.EventActionsTypes = exports.clearHandlerFromStore = exports.getEventObject = exports.ForeignEventError = exports.eventBusFromArray = void 0;
function eventBusFromArray(eventList) {
    var eventSet = new Set(eventList);
    if (eventSet.size !== eventList.length)
        console.warn('it loos like you have duplicate event names in the event list array');
    var eventBus = {};
    for (var _i = 0, _a = Array.from(eventSet); _i < _a.length; _i++) {
        var eventName = _a[_i];
        eventBus[eventName] = [];
    }
    return eventBus;
}
exports.eventBusFromArray = eventBusFromArray;
var ForeignEventError = /** @class */ (function (_super) {
    __extends(ForeignEventError, _super);
    function ForeignEventError() {
        var _this = _super.call(this, ForeignEventError.errorText) || this;
        _this.name = 'foreign event subscribtion';
        return _this;
    }
    ForeignEventError.errorText = 'it looks like you tried to subscribe to an event that is not included in the possible event options passed to useUiEvent hook';
    return ForeignEventError;
}(Error));
exports.ForeignEventError = ForeignEventError;
/**
 * generates event object with a _symbol key used as an identifier
 * to be used to unsubscribe.
 */
function getEventObject(handler, token) {
    return {
        _symbol: token,
        handler: handler,
    };
}
exports.getEventObject = getEventObject;
/**
 * used by the unsubscribe function returned from subscribe
 * function to clear the events store from a specific handler
 * through its Symbol.
 */
function clearHandlerFromStore(eventName, keySymbol, eventStore) {
    var _a;
    var eventHandlers = __spreadArray([], eventStore[eventName], true);
    var eventIndex = eventHandlers.findIndex(function (item) { return item._symbol === keySymbol; });
    if (eventIndex !== -1)
        eventHandlers.splice(eventIndex, 1);
    return __assign(__assign({}, eventStore), (_a = {}, _a[eventName] = eventHandlers, _a));
}
exports.clearHandlerFromStore = clearHandlerFromStore;
/**
 * extracts events array and excutes it to return the array after excution
 */
// export function excuteEventBus(eventName: EventName, eventStore: EventStore) {
//   const subjectEventBus: EventStore[typeof eventName] = [
//     ...eventStore[eventName],
//   ]
//   while (subjectEventBus.length > 0) {
//     const eventObject = subjectEventBus.pop() || { handler: () => null }
//     try {
//       eventObject.handler()
//     } catch (error) {
//       throw error
//     }
//   }
//   return subjectEventBus
// }
var EventActionsTypes;
(function (EventActionsTypes) {
    EventActionsTypes["subscribe"] = "subscribe";
    EventActionsTypes["unsubscribe"] = "unsubscribe";
    EventActionsTypes["emit"] = "emit";
})(EventActionsTypes = exports.EventActionsTypes || (exports.EventActionsTypes = {}));
function eventStoreReducer(state, _a) {
    var type = _a.type, payload = _a.payload;
    var eventActionsMap = {
        unsubscribe: function (state, _a) {
            var _b;
            var type = _a.type, payload = _a.payload;
            if (type !== 'unsubscribe')
                return state;
            var eventName = payload.eventName, token = payload.token;
            var eventHandlers = __spreadArray([], state[eventName], true);
            var eventIndex = eventHandlers.findIndex(function (item) { return item._symbol === token; });
            if (eventIndex === -1)
                return state;
            console.log('UNSUB: ', eventName, token);
            eventHandlers.splice(eventIndex, 1);
            return __assign(__assign({}, state), (_b = {}, _b[eventName] = eventHandlers, _b));
        },
        subscribe: function (state, _a) {
            var _b;
            var payload = _a.payload;
            var handler = payload.handler, eventName = payload.eventName, token = payload.token;
            if (!state.hasOwnProperty(eventName))
                throw new ForeignEventError();
            console.log('SUBSCRIBE: ', eventName);
            var eventHandlers = __spreadArray([], state[eventName], true);
            var eventObject = getEventObject(handler, token);
            eventHandlers.push(eventObject);
            return __assign(__assign({}, state), (_b = {}, _b[eventName] = eventHandlers, _b));
        },
        emit: function (state, _a) {
            var _b;
            var payload = _a.payload;
            var eventName = payload.eventName;
            var subjectEventBus = __spreadArray([], state[eventName], true);
            while (subjectEventBus.length > 0) {
                var eventObject = subjectEventBus.pop() || { handler: function () { return null; } };
                try {
                    eventObject.handler();
                }
                catch (error) {
                    throw error;
                }
            }
            return __assign(__assign({}, state), (_b = {}, _b[eventName] = subjectEventBus, _b));
        },
    };
    var excutedAction = eventActionsMap[type];
    console.log('EXECUTED ACTION: ', type);
    return excutedAction(state, { type: type, payload: payload });
}
exports.eventStoreReducer = eventStoreReducer;
