import { useCallback, useReducer } from 'react';
import { eventBusFromArray, EventActionsTypes, eventStoreReducer, } from './utils';
var useFormUIEvents = function (eventOptionList) {
    var _a = useReducer(eventStoreReducer, eventOptionList, eventBusFromArray), state = _a[0], dispatch = _a[1];
    var subscribe = useCallback(function (eventName, handler) {
        var eventObjectToken = Symbol();
        dispatch({
            type: EventActionsTypes.subscribe,
            payload: { eventName: eventName, handler: handler, token: eventObjectToken },
        });
        return function () {
            dispatch({
                type: EventActionsTypes.unsubscribe,
                payload: { eventName: eventName, token: eventObjectToken },
            });
        };
    }, []);
    var emit = useCallback(function (eventName) {
        dispatch({
            type: EventActionsTypes.emit,
            payload: { eventName: eventName }
        });
    }, []);
    return { emit: emit, subscribe: subscribe };
};
export default useFormUIEvents;
